# ======================================================================================================================
#   Operadores para variaveis de mesmo dominio
# ----------------------------------------------------------------------------------------------------------------------
#   Autor: Rafael Hideo Toyomoto
#   22/08/2018
# ======================================================================================================================

from base.operation import NormOperator

# ----------------------------------------------------------------------------------------------------------------------


class CoNormOperator(NormOperator):
    def __init__(self, func_x, func_y, color=None):
        NormOperator.__init__(self, func_x, func_y, color=color)

# ----------------------------------------------------------------------------------------------------------------------


class CoNorm4(CoNormOperator):
    def calc_z(self, x, y):
        a = self.func_x.calc(x)
        b = self.func_y.calc(y)
        return a + b - a*b

# ----------------------------------------------------------------------------------------------------------------------


class CoNorm9(CoNormOperator):
    def calc_z(self, x, y):
        a = self.func_x.calc(x)
        b = self.func_y.calc(y)
        return max(a, b)

# ======================================================================================================================
